# Table of contents

* [Polyphony - Easy Concurrency for Ruby](../README.md)

## Getting Started

* [Installing](getting-started/installing.md)
* [Tutorial](getting-started/tutorial.md)

## Technical overview

* [Design Principles](technical-overview/design-principles.md)
* [Concurrency the Easy Way](technical-overview/concurrency.md)
* [How Fibers are Scheduled](technical-overview/fiber-scheduling.md)
* [Exception Handling](technical-overview/exception-handling.md)
* [Frequently Asked Questions](technical-overview/faq.md)

## How To

* [Make an echo server](howto/echo-server.md)
* [Make an HTTP server](howto/http-server.md)
* [Make a Websocket server](howto/websocket-server.md)
* [Use timers](howto/timers.md)
* [Throttle recurrent operations](howto/throttle.md)
* [Cancel ongoing operations](howto/cancel.md)
* [Control coprocesses](howto/coprocesses.md)
* [Synchronize concurrent operations](howto/synchronize.md)
* [Perform CPU-bound operations](howto/cpu-bound.md)
* [Control backpressure](howto/backpressure.md)
* [Fork worker processes](howto/worker-processes.md)

## Polyphony extensions

* [Postgresql](extensions/pg)
* [Redis](extensions/redis)
* [IRB](extensions/irb)
* [Throttlers](#)
* [Resource Pools](#)
* [Synchronisation](#)
* [Web Server](user-guide/web-server.md)
* [Websocket Server](#)
* [Reactor API](#)

## API Reference

* [Polyphony::CancelScope](#)
* [Polyphony::Coprocess](#)
* [Gyro](#)
* [Gyro::Async](#)
* [Gyro::Child](#)
* [Gyro::IO](#)
* [Gyro::Timer](#)
* [Kernel](#)
* [Polyphony](#)
* [Polyphony::Mutex](#)
* [Polyphony::Pulser](#)
* [Polyphony::ResourcePool](#)
* [Polyphony::Throttler](#)

## [Contributing to Polyphony](contributing.md)